SystemOrganization addCategory: #'TOC-Declaration-Core'!
SystemOrganization addCategory: #'TOC-Declaration-Visitor'!
SystemOrganization addCategory: #'TOC-Tracking-Core'!
SystemOrganization addCategory: #'TOC-Tracking-Visitor'!

!MCClassDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/18/2012 17:56'!
hasInstanceVariable: varName metaClass: isMeta
	^ (isMeta 
		ifTrue: [(self selectVariables: #isClassInstanceVariable) 
				union: (self selectVariables: #isClassVariable)] 
		ifFalse: [self selectVariables: #isInstanceVariable]) includes: varName! !

RBProgramNodeVisitor subclass: #TODeclarationVisitor
	instanceVariableNames: 'accepted mthDef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

TODeclarationVisitor subclass: #TODAbstractSelectorVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODAbstractSelectorVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:58'!
acceptMessageNode: aMessageNode 
	((aMessageNode receiver isVariable) and: [aMessageNode receiver name = 'self']) ifTrue: [
		aMessageNode selector = #subclassResponsibility ifTrue: [
			accepted := true.
			^ self]].
	super acceptMessageNode: aMessageNode .
! !

TODeclarationVisitor subclass: #TODGetterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODGetterVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:35'!
acceptReturnNode: aReturnNode 
	|lit|
	lit := aReturnNode value.
	((lit isVariable) and: [lit isLocallyBound not]) ifTrue: [accepted := true]! !

TODeclarationVisitor subclass: #TODTypePredicateVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypePredicateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:42'!
acceptReturnNode: aReturnNode 
	|lit|
	lit := aReturnNode value.
	((lit isLiteralNode) and: [lit value isKindOf: Boolean]) ifTrue: [accepted := true]
	! !

TODeclarationVisitor subclass: #TODTypeStateVisitor
	instanceVariableNames: 'hasReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:35'!
acceptReturnNode: aReturnNode 
	hasReturn := true.
	super acceptReturnNode: aReturnNode .! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:24'!
acceptVariableNode: aVariableNode
	|name |
	name := aVariableNode name.
	(#(self super) includes: name) ifTrue: [ accepted := true. ^self.].
	
	"dependent on FEFI"
	aVariableNode  isLocallyBound ifFalse: [ accepted := true]
	
	 
	 ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:34'!
accepted 
	^ accepted & hasReturn ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:32'!
initialize 
	super initialize .
	hasReturn := false.! !

!TODeclarationVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:46'!
accept: def
	^ self new mthDef: def  ; 
		visitNode: (RBParser permissiveParseMethod: def source) ; 
		accepted
	 ! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
accepted 
	^ accepted ! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
initialize 
	super initialize .
	accepted := false.! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:47'!
mthDef: cdef
	mthDef := cdef ! !

TODeclarationVisitor subclass: #TOFilterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

TOFilterVisitor subclass: #TOFDoesNotUnderstandVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFDoesNotUnderstandVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:49'!
acceptMethodNode: aMethodNode 
	accepted :='doesNotUnderstand*' match: aMethodNode selector! !

TOFilterVisitor subclass: #TOFNonBoolVisitor
	instanceVariableNames: 'hasReturn avoid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:11'!
acceptMessageNode: aMessageNode
	
	aMessageNode selector = #subclassResponsibility ifTrue: [avoid := true . ^self].
	
	super acceptMessageNode: aMessageNode .! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:01'!
acceptReturnNode: aReturnNode 
	|node|
	hasReturn := true.
	node := aReturnNode value.
	node isLiteralNode ifTrue: [
		(node value isKindOf: Boolean) ifFalse: [accepted :=true]].
	((node isVariable) and: [#(self super) includes: node name]) ifTrue: [accepted := true]! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:11'!
accepted 
	^ avoid not and: [accepted | hasReturn not].! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:10'!
initialize 
	super initialize .
	hasReturn := false.
	avoid := false.! !

TOFilterVisitor subclass: #TOFNonLocalVisitor
	instanceVariableNames: 'firstVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFNonLocalVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 23:23'!
acceptVariableNode: aVariableNode
	|cls|
	(aVariableNode isRead | aVariableNode isWrite) ifFalse: [^ self].
	firstVar ifFalse: [firstVar := accepted := true].
	(#(self super thisContext) includes: aVariableNode name) ifTrue: [accepted := false . ^ self].
	cls := mthDef clsDef.
	(aVariableNode isLocallyBound) ifFalse:[
		cls ifNotNil: [
			(cls hasInstanceVariable: aVariableNode name metaClass: mthDef classIsMeta)
				ifTrue: [accepted :=false. ^ self] ] 
			ifNil: [
			(aVariableNode name isClassName) 
				ifFalse: [ accepted := false. ^ self]]].
	
	
	  ! !

!TOFNonLocalVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 19:12'!
initialize 
	super initialize.
	firstVar := false.! !

!TOFilterVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:38'!
canBeFilter: def
	^ self subclasses anySatisfy: [:filter | filter accept: def]! !

TODeclarationVisitor subclass: #TOXState2TypeVisitor
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOXState2TypeVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:28'!
accept: def inProject: pjt
	^ self new mthDef: def  ; project: pjt ;
		visitNode: (RBParser permissiveParseMethod: def source) ; 
		accepted! !

!TOXState2TypeVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:23'!
acceptReturnNode: aReturnNode 
	|node|
	node := aReturnNode value.
	node isMessage ifFalse: [^ self].
	(node receiver isVariable and: [#(self super) includes: node receiver name]) ifFalse: [^ self].
	(self isTypePredicate: node selector) ifTrue: [accepted := true].! !

!TOXState2TypeVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:42'!
isTypePredicate: selector
	^ project hasTypePredicate: mthDef fullClassName2, '>>', selector  ! !

!TOXState2TypeVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:23'!
project: pjt
	project := pjt.! !

!RBParser class methodsFor: '*toc-declaration' stamp: 'OzC 12/16/2011 20:57'!
permissiveParseMethod: source
	[^ RBParser parseMethod: source] on: Error do: [:e | Transcript cr; show: e].
	^ RBParser parseMethod: 'notValidMethodFailToParse'! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 1/21/2012 15:10'!
retrieveAll
	|doc|
	doc:= self retrieveDeclarations.
	^ {doc . self retrieveAllUsagesWith: doc declarations}! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 1/21/2012 15:15'!
retrieveAllUsagesWith: dict
	dict loadFixedSelectors.
	projects do: [:p|
		p versions last mcVersion findUsagesIn: dict.
		] displayingProgress: 'Finding usages'.
	^ dict
	! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 1/26/2012 08:14'!
retrieveDeclarations
	|doc|
	doc:= TOProjectDictionary new.
	projects do: [:p| |dot name|
		name := p projectName.
		dot := doc at: name ifAbsentPut: (TOProject new projectName: name).
		p versions last mcVersion loadDeclarationIn: dot.
		dot isEmpty 
			ifTrue: [doc removeKey: name] 
			ifFalse: [dot loadClassNames ; fixPredicates].
		] displayingProgress: 'Loading declarations'.
	^doc! !

!RBLiteralNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 15:03'!
inLHighO 
	^ self inLPattern: #(#select: reject:)! !

!Symbol methodsFor: '*toc-declaration' stamp: 'OzC 1/26/2012 08:19'!
todPattern
	1 to:  self size do: [:i| |chr|
		chr:= self at: i.
		(chr isUppercase) "| (chr = $:)" ifTrue: [^ self first: (i-1)]].
	^  nil
	! !

!Symbol methodsFor: '*toc-declaration' stamp: 'OzC 1/26/2012 08:22'!
todPropertyName
	|ptt|
	ptt := self todPattern .
	ptt ifNil: [^ nil].
	^ self  last: (self size - ptt size)! !

FDataVisitor subclass: #TOTrackingVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Visitor'!

!TOTrackingVisitor commentStamp: '<historical>' prior: 0!
TOTrackingVisitor has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	mthDef	FMthDef 
	fusages	OrderedCollection 
	usages	(Selector -> OrderedCollection )!

!TOTrackingVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/21/2012 15:24'!
onDef: def find: dict
	^ (self on: dict) def: def ; visit: (RBParser permissiveParseMethod: def source) ; yourself ! !

!TOTrackingVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 23:07'!
acceptLiteralNode: aLiteralNode
	|value|
	value := aLiteralNode value.
	value isSymbol ifFalse: [^ self].
	dict keysAndValuesDo: [:selector :ls |
		selector = value ifTrue: [ ls  senders add: (FIdentifierDef newFrom: def andParentExpr: aLiteralNode parent) ]
		].
	! !

!TOTrackingVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:52'!
acceptMessageNode: msgNode
	super acceptMessageNode: msgNode.

	dict do: [ :ls |
		(ls acceptSelector: msgNode) ifTrue: [ ls senders add: (FMessageDef newFrom: def andMsg: msgNode) ]
		]! !

FMthDef subclass: #TOMCMethodDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/22/2012 16:08'!
findUsagesIn: tod mcVersion: mc
	TOTrackingVisitor onDef: ( (self as: TOMCMethodDefinition) mcVersion: mc) 
					    find: tod 
						 
	! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
fullClassName2

	^ self classIsMeta
		ifFalse: [self className]
		ifTrue: [self className, ' class']! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/18/2012 12:34'!
loadDeclarationIn: toc mcVersion: mc
	|def clsDef|
	(toc matchSelector: self selector) ifFalse: [^self].
	def := ((self as: TOMCMethodDefinition) mcVersion: mc).
	(TOFilterVisitor canBeFilter: def ) ifTrue: [^ self]. 
	toc addSelector: def. 
	
	! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
tocName 
	^ self fullClassName2 ,'>>',selector ! !

!RBMessageNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 15:10'!
inLHighO
	|parent2|
	parent2 := self parents select: #isBlock.
	parent2 isEmpty ifTrue: [^ false].
	^ parent2 first inLPattern: #(select: reject:) ! !

Dictionary subclass: #TODSelectorDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:54'!
addSelector: "(MCMthDef)" mthDef
	|selectors|
	selectors := self at: mthDef selector ifAbsentPut: [TODSelector new selector: mthDef selector].
	selectors implementors add: (TOSelector createFrom: mthDef) 
	! !

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:49'!
allValues
	^ self value inject: OrderedCollection new into: [:ls :tod | ls addAll: tod implementors ; yourself] ! !

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:49'!
hasTypePredicate: selector
	self at: selector ifAbsent: [^ false].
	^ (self at: selector) implementors anySatisfy: #isTypePredicate 
	! !

!TODSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:46'!
printString 
	^ (self size),'selectors'! !

Dictionary subclass: #TOProjectDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 1/10/2012 22:36'!
allAbstracts
	^ self allCategory: #isAbstractSelector! !

!TOProjectDictionary methodsFor: 'flat-selectors-core' stamp: 'OzC 1/10/2012 22:57'!
allCategories
	^ (self class allSelectorsInCategory: 'flat-selectors-category') collect: [:sel |
		sel -> (self perform: sel) size]! !

!TOProjectDictionary methodsFor: 'flat-selectors-core' stamp: 'OzC 1/25/2012 21:56'!
allCategory: ctg
	^ self  inject: SortedCollection new into: [:sor :pot|
		sor addAll: (pot selectors allValues select: ctg) ; yourself].! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:41'!
allExtras
	^ self allCategory: #isExtra! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:51'!
allProjectsWithCategory: ctg
	^ self select: [:top | (top selectors allValues select: ctg) size > 0]! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:31'!
allProjectsWithMixPredicates
	^ self shouldBeImplemented ! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:52'!
allProjectsWithTypePredicates
	^ self select: [:top | (top selectors allValues select: #isTypePredicate) size > 0]! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:42'!
allStatePredicates
	^ self allCategory: #isStatePredicate! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:41'!
allTypePredicates
	^ self allCategory: #isTypePredicate! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:55'!
allWithSource: source
	^ self  inject: SortedCollection new into: [:sor :pot|
		sor addAll: (pot selectors allValues select: [:tos|
			source match: tos mthDef source]) ; yourself].! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:30'!
declarations 
	^ self values inject: TOSelectorDictionary new into: [:dec :pot | 
		dec addImplementors: pot selectors values]
	! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 23:51'!
printString 
	^ (self size asString ),'projects'! !

Dictionary subclass: #TOSelectorDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:30'!
addImplementors: toss
	toss do: [:tos| 
		self at: tos selector 
			  ifAbsentPut: [tos as: TOTSelector]]! !

!TOSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 16:00'!
all: ctg
	^ self values inject: OrderedCollection new into: [:ls :tos | ls addAll: (tos perform: ctg) ; yourself] ! !

!TOSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 16:00'!
allImplementors
	^ self all: #implementors! !

!TOSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 16:01'!
allSenders
	^ self all: #senders! !

!TOSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:08'!
fixedSelectors 
	^ self select: [:tos | (TOTFixedSelectors defaultSelectors)includes: tos selector].! !

!TOSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:12'!
loadFixedSelectors 
	TOTFixedSelectors subclasses  do: [:fClass | |sd|
		sd:=self at: fClass defaultSelector  
			 ifAbsentPut: [TOTFixSelector new selector: fClass defaultSelector  ; fClass: fClass].
		sd isFixSelector ifFalse: [sd becomeForward: ((sd as: TOTFixSelector) fClass: fClass)]]! !

!TOSelectorDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:48'!
topSenders
	^ self copy values sort: [:a :b | a senders size >= b senders size]
	! !

!MCPackage methodsFor: '*toc-monticello' stamp: 'OzC 12/21/2011 13:25'!
projectName 
	^ self name copyUpTo: $-! !

!MCDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/19/2012 10:31'!
findUsagesIn: toc mcVersion: mcVersion
	! !

!MCDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/20/2011 14:39'!
loadDeclarationIn: toc mcVersion: mcVersion
	! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:15'!
inComplex
	^ expr inLComplex ! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:14'!
inFlow
	^ expr inLFlow! !

!FDataDef methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:15'!
inHighO
	^ expr inLHighO  ! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:18'!
inLComplex
	^ false! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:17'!
inLFlow 
	^ false! !

!RBProgramNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:18'!
inLHighO 
	^ false! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:12'!
inLComplex
	^ self inLPattern: #(not and: or: xor:)! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:12'!
inLFlow
	^ self inLPattern: #(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:)! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 15:00'!
inLHighO
	^ false! !

!RBValueNode methodsFor: '*toc-tracking' stamp: 'OzC 1/26/2012 13:09'!
inLPattern: selectors
	^ parent  isMessage  and: [ selectors includes: parent selector ]
	! !

Object subclass: #TODSelector
	instanceVariableNames: 'selector implementors iclassNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TODSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 08:20'!
iclassNames
	^ iclassNames ifNil: [|mcVersion|
		mcVersion := implementors first mthDef mcVersion.
		iclassNames := mcVersion classPartiallyNamed: selector todPropertyName 
								     withSelector: selector].! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 07:39'!
implementors
	^ implementors! !

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:42'!
initialize 
	super initialize .
	implementors := SortedCollection new.! !

!TODSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:49'!
printString 
	^ selector ,'  ',implementors size asString ,'impl.'! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 07:39'!
selector
	^ selector! !

!TODSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 07:39'!
selector: anObject
	selector := anObject! !

TODSelector subclass: #TOTSelector
	instanceVariableNames: 'senders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

TOTSelector subclass: #TOTFixSelector
	instanceVariableNames: 'fClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTFixSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:53'!
acceptSelector: node 
	^ fClass acceptSelector: node ! !

!TOTFixSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 10:04'!
fClass
	^ fClass! !

!TOTFixSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 10:04'!
fClass: anObject
	fClass := anObject! !

!TOTFixSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:12'!
isFixSelector 
	^ true! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:53'!
acceptSelector: node 
	^ selector = node selector   ! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 15:57'!
iProjectNames
	^ implementors inject: Set new into: [:set :tos | set add: tos projectName  ; yourself] ! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:25'!
iclassNames 
	^ self shouldNotImplement! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:42'!
initialize 
	super initialize .
	senders := SortedCollection new.! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 10:12'!
isFixSelector
	^ false! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 1/22/2012 22:53'!
isOverUsed
	^ self iProjectNames size < self sProjectNames size! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 1/22/2012 22:29'!
isSingle
	|ip|
	ip:= self iProjectNames .
	^ ip size = 1 and: [ip = self sProjectNames ]! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 07:43'!
printString 
	^ super printString,' ' ,senders size asString,'send'! !

!TOTSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 16:07'!
sProjectNames
	^ senders inject: Set new into: [:set :tos | set add: tos senderProjectName  ; yourself] ! !

!TOTSelector methodsFor: 'accessing' stamp: 'OzC 1/26/2012 08:40'!
senders
	^ senders ifNil: [senders := SortedCollection new.]! !

Object subclass: #TOProject
	instanceVariableNames: 'projectName selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProject class methodsFor: 'selector-patterns' stamp: 'OzC 1/25/2012 09:39'!
matchSelector: selector
	self selectorPatterns do:[:patt|  |idx|
		idx := patt size + 1.
		(((patt , '#*') match: selector) and: [
			((selector at: idx) isUppercase & ( (selector last) ~= $: ))]) ifTrue: [^ true]
		].
	^ false
! !

!TOProject class methodsFor: 'selector-patterns' stamp: 'OzC 1/25/2012 21:26'!
selectorPatterns
	^#(is has does should shall can could may maybe might would will not "if")! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:34'!
addSelector: "(MCMthDef)" mthDef
	selectors addSelector: mthDef
	! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:32'!
fixPredicates
	|ls|
	ls := selectors allValues select: [:tos | tos isStatePredicate 
			and: [TOXState2TypeVisitor accept: tos mthDef inProject: self]].
	"ls do: [:tos | tos as: TOTypePredicateSelector]."
	^ ls
	"self inject: Set new into: [:ss :pot |
	ss addAll: pot fixPredicates . ss]"! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:35'!
hasTypePredicate: selector
	^ selectors hasTypePredicate: selector ! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 21:31'!
initialize 
	selectors := TODSelectorDictionary new.! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 12:59'!
isEmpty
	^ selectors size == 0! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:22'!
loadClassNames 
	selectors do: #iclassNames! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 19:58'!
matchSelector: selector
	^ self class matchSelector: selector ! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 1/25/2012 22:47'!
printString 
	|name|
	name := projectName,' ',(selectors size asString),'#'.
	(selectors size) > 0 ifTrue:  [
		{#isTypePredicate -> 'type' . #isStatePredicate->'state' . #isAbstractSelector -> 'abstr' . #isExtra -> 'extra'} do: [:pair|
			name := name, ', ',(selectors allValues select: pair key) size asString,(pair value)]].
	^ name! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName
	^ projectName! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName: anObject
	projectName := anObject! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
selectors
	^ selectors! !

Object subclass: #TOSelector
	instanceVariableNames: 'mthDef validated unvalidated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

TOSelector subclass: #TOAbstractSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOAbstractSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:53'!
shortName 
	^ 'Abstract'! !

!TOAbstractSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:53'!
visitorClass 
	^ TODAbstractSelectorVisitor! !

!TOAbstractSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:52'!
isAbstractSelector 
	^ true! !

TOSelector subclass: #TOExtraSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOExtraSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Extra'! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isExtra
	^true! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:10'!
validate: def
	self class visitorClasses do: [:tot|
		(tot visitorClass accept: def) 
			ifTrue: [self unvalidated add: def. ^self]].
	self validated add: def.! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 00:49'!
createFrom: mthDef
	"order define precendece"
	self visitorClasses do: [:tot|
		(tot visitorClass accept: mthDef) ifTrue: [^ tot new mthDef: mthDef] ].
	^ TOExtraSelector new mthDef: mthDef  ! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ self subclassResponsibility ! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:31'!
visitorClasses
	^
	"order define precendece"
	{TOAbstractSelector . TOGetterSelector . TOStatePredicateSelector . TOTypePredicateSelector} ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:41'!
<= another
	self selector  = another selector ifFalse: [^ self selector <= another selector].
	^ self mthDef tocName <= another mthDef tocName ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:11'!
classNames 
	^ (mthDef mcVersion classPartiallyNamed: self propertyName withSelector: self selector)! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:36'!
duplicatesLength
	|n|
	n:= validated ifNil: [0] ifNotNil: [validated size]. 
	n:= n + (unvalidated ifNil: [0] ifNotNil: [unvalidated size]). 
	^ n! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/21/2011 13:52'!
isAbstractSelector 
	^ false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isExtra
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 1/18/2012 11:36'!
isGetter
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/21/2011 13:43'!
isStatePredicate
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isTypePredicate
	^false! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/16/2011 20:05'!
mthDef
	^ mthDef! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:07'!
mthDef: def
	mthDef := def! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:19'!
pattern
	^ mthDef selector todPattern ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 11:30'!
printString 
	^ self class shortName, '[',mthDef tocName,']'! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 15:57'!
projectName 
	^ mthDef projectName ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 08:20'!
propertyName
	^mthDef selector todPropertyName ! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:06'!
selector
	^ mthDef selector! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
unvalidated 
	^ unvalidated ifNil: [unvalidated := Set new.]! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:03'!
validate: def
	((self class visitorClass accept: def) 
		ifTrue: [self validated] ifFalse:[ self unvalidated]) add: def! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
validated 
	^ validated ifNil: [validated := Set new.]! !

TOSelector subclass: #TOStatePredicateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

TOStatePredicateSelector subclass: #TOGetterSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOGetterSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 10:39'!
shortName 
	^ 'Getter'! !

!TOGetterSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 10:40'!
visitorClass 
	^ TODGetterVisitor! !

!TOGetterSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:36'!
isGetter 
	^ true! !

!TOStatePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:33'!
shortName 
	^ 'State'! !

!TOStatePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypeStateVisitor! !

!TOStatePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:43'!
isStatePredicate  
	^ true! !

TOSelector subclass: #TOTypePredicateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Type'! !

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypePredicateVisitor! !

!TOTypePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isTypePredicate 
	^true! !

Object subclass: #TOTFixedSelectors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

TOTFixedSelectors subclass: #TOTEmptyFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTEmptyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:58'!
defaultSelector 
	^ #isEmpty! !

!TOTEmptyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 14:45'!
fSelectors 
	^ #( #isEmpty #notEmpty #isEmptyOrNil)! !

!TOTEmptyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:11'!
patternBlock
	^ [:a :b | (a isLiteralNode and: [a value == 0]) and: [b isMessage and: [b selector == #size]]]
	! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:13'!
acceptAlternative: node
 	(self alternativeSelectors includes: node selector) ifFalse: [^ false] .
	^ (self patternBlock value: node receiver value: node arguments first) 
	or: [self patternBlock value: node arguments first value: node receiver] ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:27'!
acceptSelector: node
	^ (self fSelectors includes: node selector) or: [
		self acceptAlternative: node]  ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:01'!
alternativeSelectors
	^#(#= #== #~=)! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:48'!
defaultSelector
	^ self subclassResponsibility ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:54'!
defaultSelectors
	^ self subclasses inject: OrderedCollection new into: [:ls :cls | 
		cls isActive ifTrue:[ls add: cls defaultSelector] . ls]! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 10:29'!
fSelectors
	^ self subclassResponsibility ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:55'!
fixedSelectors
	^ self subclasses inject: OrderedCollection new into: [:ls :cls | 
		cls isActive ifTrue:[ls addAll: cls fSelectors] . ls]! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:57'!
isActive 
	^ true ! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:18'!
patternBlock 
	^ [:a :b | false]! !

!TOTFixedSelectors class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:28'!
shortName
	^ self subclassResponsibility ! !

TOTFixedSelectors subclass: #TOTKindOfFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:49'!
defaultSelector 
	^ #isKindOf:! !

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:20'!
fSelectors
	^  #(#isKindOf: #isMemberOf:)! !

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:16'!
patternBlock
	^ [:a :b | (a isVariable and: [a name isClassName]) or: [b isMessage and: [b selector == #class]]]! !

!TOTKindOfFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:29'!
shortName
	^ 'kindOf'! !

TOTFixedSelectors subclass: #TOTNilFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:49'!
defaultSelector 
	^ #isNil! !

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 10:17'!
fSelectors
	^  #(#haltIfNil #ifNil: #ifNil:ifNotNilDo: #ifNil:ifNotNil: #ifNotNilDo: #ifNotNilDo:ifNil: #ifNotNil: #ifNotNil:ifNil: #isEmptyOrNil #isNil #notNil)! !

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:17'!
patternBlock
	^ [:a :b | (a isLiteralNode and: [a value == nil])]! !

!TOTNilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:29'!
shortName
	^ 'nil'! !

TOTFixedSelectors subclass: #TOTPropertyFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTPropertyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:57'!
defaultSelector 
	^#valueOfProperty:! !

!TOTPropertyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:57'!
fSelectors 
	^ #(#valueOfProperty: #valueOfProperty:ifAbsentPut: #valueOfProperty:ifAbsent: #valueOfProperty:ifPresentDo:)! !

!TOTPropertyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:56'!
isActive 
	^ false! !

!TOTPropertyFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:29'!
shortName
	^ 'property'! !

TOTFixedSelectors subclass: #TOTStructuralCheckFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTStructuralCheckFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:50'!
defaultSelector 
	^ #respondsTo:! !

!TOTStructuralCheckFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:27'!
fSelectors 
	^#(#respondsTo: #canUnderstand:)! !

!TOTStructuralCheckFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/23/2012 22:29'!
shortName
	^ 'structural'! !

TOTFixedSelectors subclass: #TOTZeroFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!TOTZeroFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:59'!
defaultSelector 
	^ #isZero! !

!TOTZeroFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 09:59'!
fSelectors 
	^ #( #isZero)! !

!TOTZeroFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/26/2012 11:18'!
patternBlock
	^ [:a :b | (a isLiteralNode and: [a value == 0])]! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/25/2012 10:12'!
anyClassNameSatisfy: name
	snapshot definitions anySatisfy: [:def | def classNameSatisfy: name]! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/25/2012 22:54'!
classPartiallyNamed: name
	|ls|
	ls := OrderedCollection new.
	snapshot definitions do: [:def | 
		(def isMethodDefinition and: [ ('*',name,'*') match: def fullClassName2]) 
			ifTrue: [ls add: def fullClassName2 ]].
	^ ls! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/25/2012 23:46'!
classPartiallyNamed: name withSelector: selector
	|ls|
	ls := OrderedCollection new.
	snapshot definitions do: [:def | 
		(def isMethodDefinition 
			and: [( ('*',name,'*') match: def fullClassName2) & (def selector = selector) ] ) 
				ifTrue: [ls add: def fullClassName2 ]].
	^ ls! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/23/2012 11:42'!
findUsagesIn: tod
	snapshot definitions do: [:def |
		def findUsagesIn: tod mcVersion: self.] displayingProgress: 'Inspecting: ', self package projectName 
	! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 12/21/2011 13:24'!
isInTop1000 
	^ FSource cachedPkgCtg includesKey: self package projectName ! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 1/23/2012 11:42'!
loadDeclarationIn: "(TOProject)"toc 
	snapshot definitions do: [:def |
		def loadDeclarationIn: toc mcVersion: self.] displayingProgress: 'Loading: ', self package projectName 
	! !
